import java.util.*;
import java.awt.*;
import java.awt.event.*;

/** Klasse zum darstellen der Bannertexte und Programm beenden beim Fensterschlieen
  *
  * @author Bernhard Fiser 0109815
  */
public class Wnd extends Frame
{
	/* Hashmap zur Speicherung der Zeicheninformationen */
	private HashMap		hmap;
	/* LinkedList zur Speicherung der Bannertexte */
	private LinkedList	tlist;

	/** Fenster ffnen und Instanzvariablen initialisieren */
	public Wnd(HashMap h, LinkedList l)
	{
		/* Fenster erstellen und Titeltext setzen */
		super("Banner");
		/* Instanzvariablen setzen */
		this.hmap = h;
		this.tlist = l;
		/* Handler fr das Fensterschlieen setzen */
		addWindowListener(new WndClose());
		/* Fenstergre und -farbe setzen */
		setSize(500, 500);
		setBackground(Color.white);
		/* Fenster anzeigen */
		show();
	}

	/** "Fensterschlie-Handler"
	  * Dieser wird aufgerufen falls das Fenster geschlossen wird */
	class WndClose extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			/* Meldung ausgeben und Programm beenden */
			System.out.println("Window closed and exit");
			System.exit(0);
		}
	}

	/** Grafik zeichnen.
	  * Diese Methode wird aufgerufen, falls der Inhalt des Fensters
	  * neu gezeichnet werden mu */
	public void paint(Graphics g)
	{
		int		i,
				xoff,
				yoff;
		char		c;
		CharElement	ce;
		CharDef		cd;
		ListIterator	li, tli;
		String		txt;
		int		zoom;
		BannerElement	be;

		/* Listeniterator der Bannertexte initialisieren */
		tli = tlist.listIterator(0);
		/* Absolute Y-Startposition setzen */
		yoff = 50;
		/* Schleife ber alle Bannertexte aus der Liste */
		while (tli.hasNext())
		{
			/* Bannerelement aus Liste auslesen */
			be = (BannerElement) tli.next();
			/* Bannertext und Zoomfaktor auslesen */
			txt = be.getText();
			zoom = be.getZoom();
			/* Absolute X-Startposition setzen */
			xoff = 30;
			/* Schleife ber alle Zeichen des Bannertextes */
			for (i = 0; i < txt.length(); i++)
			{
				/* Zeichenelementliste aus Hashmap auslesen */
				if ((cd = (CharDef) hmap.get(new Character(txt.charAt(i)))) != null)
				{
					/* Falls Zeichen in Hashmap exisistiert, Iterator
					 * ber die ELementliste erstellen */
					li = cd.listIterator(0);
					/* Schleife ber alle Elemente des Zeichens */
					while(li.hasNext())
					{
						/* Zeichenelement aus Liste auslesen */
						ce = (CharElement) li.next();
						/* Zeichenelement zeichnen */
						ce.draw(xoff, yoff, zoom, g);
					}
				}
				/* Absolute X-Position erhhen fr nchstes Zeichen */
				xoff += 8 * zoom;
			}
			/* Absolute Y-Position erhhen fr nchsten Bannertext */
			yoff += 8 * zoom;
		}
	}
}
